dofile(minetest.get_modpath("slender").."/api.lua")

minetest.register_abm(
        {nodenames = {"slender:slenderwater"},
        interval = 30,
        chance = 2,
        action = function(pos)
                pos.y=pos.y+0
                minetest.env:add_node(pos, {name="air"})
        end,
})

minetest.register_node("slender:slenderwater_flowing", {
	description = "Flowing Fear",
	inventory_image = minetest.inventorycube("nothing.png"),
	drawtype = "flowingliquid",
	tiles = {"slenderwater.png"},
	special_tiles = {
		{
			image="slenderwater.png",
			backface_culling=false,
		},
		{
			image="slenderwater.png",
			backface_culling=true,
		},
	},
	paramtype = "light",
	paramtype2 = "flowingliquid",
	walkable = false,
	pointable = false,
	diggable = false,
	buildable_to = true,
	drop = "",
	drowning = 1,
	liquidtype = "flowing",
	liquid_alternative_flowing = "slender:slenderwater_flowing",
	liquid_alternative_source = "slender:slenderwater",
	liquid_viscosity = LAVA_VISC,
	liquid_renewable = false,
	damage_per_second = 1*1,
	post_effect_color = {a=0, r=0, g=0, b=0},
	groups = {liquid=2, hot=3, not_in_creative_inventory=1},
})

minetest.register_node("slender:slenderwater", {
	description = "Source of fear",
	inventory_image = minetest.inventorycube("nothing.png"),
	drawtype = "liquid",
	tiles = {"nothing.png"},
	paramtype = "light",
	walkable = false,
	pointable = false,
	diggable = false,
	buildable_to = true,
	drop = "",
	drowning = 1,
	liquidtype = "source",
	liquid_alternative_flowing = "slender:slenderwater_flowing",
	liquid_alternative_source = "slender:slenderwater",
	liquid_viscosity = LAVA_VISC,
	liquid_renewable = false,
	damage_per_second = 1*1,
	post_effect_color = {a=0, r=0, g=0, b=0},
	groups = {liquid=2, hot=3,},
})

slender:register_mob("slender:slenderman", {
	type = "monster",
	hp_max = 999,
	collisionbox = {-0.2, -1.21875, -0.2, 0.2, 1.21875, 0.2},
	visual = "upright_sprite",
	visual_size = {x=1.875, y=2.4375},
	textures = {"slenderman.png"},
	makes_footstep_sound = true,
	view_range = 20,
	walk_velocity = 40,
	run_velocity = 1,
	damage = 5,
	drops = {},
	armor = 60,
	drawtype = "front",
	water_damage = 0,
	lava_damage = 0,
	light_damage = 0,
	on_rightclick = nil,
	attack_type = "shoot",
	arrow = "slender:slenderball",
	shoot_interval = 6,
	jump = true,
	step = 0.5,
	blood_texture = "wool_red.png",
})

slender:register_arrow("slender:slenderball", {
	visual = "sprite",
	visual_size = {x=1, y=1},
	textures = {"slenderball.png"},
	velocity = 5,
	hit_player = function(self, player)
		local s = self.object:getpos()
		local p = player:getpos()
		local vec = {x=s.x-p.x, y=s.y-p.y, z=s.z-p.z}
		player:punch(self.object, 1.0,  {
			full_punch_interval=1.0,
			damage_groups = {fleshy=5},
		}, vec)
		local pos = self.object:getpos()
		for dx=-1,1 do
			for dy=-1,1 do
				for dz=-1,1 do
					local p = {x=pos.x+dx, y=pos.y+dy, z=pos.z+dz}
					local n = minetest.env:get_node(pos).name
					if minetest.registered_nodes[n].groups.flammable or math.random(1, 1) <= 1 then
						minetest.env:set_node(p, {name="slender:slenderwater"})
					else
						minetest.env:remove_node(p)
					end
				end
			end
		end
	end,
	hit_node = function(self, pos, node)
		for dx=-1,1 do
			for dy=-2,1 do
				for dz=-1,1 do
					local p = {x=pos.x+dx, y=pos.y+dy, z=pos.z+dz}
					local n = minetest.env:get_node(pos).name
					if minetest.registered_nodes[n].groups.flammable or math.random(1, 1) <= 1 then
						minetest.env:set_node(p, {name="slender:slenderwater"})
					else
						minetest.env:remove_node(p)
					end
				end
			end
		end
	end
})

if minetest.setting_get("log_mods") then
	minetest.log("action", "slender_loaded")
end



